package com.fossgalaxy.games.tbs.editor;

import com.fossgalaxy.games.tbs.editor.EditorView.EditorModel;
import com.fossgalaxy.games.tbs.io.map2.MapDef;

import javax.swing.*;
import java.awt.event.ActionEvent;

public class NewAction extends AbstractAction {
    private EditorModel model;

    public NewAction(EditorModel model){
        super("New");
        this.model = model;
    }

    @Override
    public void actionPerformed(ActionEvent actionEvent) {

        String name = JOptionPane.showInputDialog("map size?");
        if (name == null) {
            return;
        }

        String[] parts = name.split("[,xX]");

        if (parts.length != 2) {
            JOptionPane.showMessageDialog(null, "size should be of the format xXy", "Invalid size", JOptionPane.ERROR_MESSAGE);
            return;
        }

        try {
            int x = Integer.parseInt(parts[0]);
            int y = Integer.parseInt(parts[1]);

            MapDef def = new MapDef(x, y, 2, 60);
            model.setMapDef(def);

        } catch (NumberFormatException ex) {
           JOptionPane.showMessageDialog(null, "Invalid number provided", "Invalid number", JOptionPane.ERROR_MESSAGE);
        }

    }

}
