package com.fossgalaxy.games.tbs.editor.tools;

import com.fossgalaxy.games.tbs.io.map2.MapDef;
import com.fossgalaxy.games.tbs.parameters.EntityType;
import com.fossgalaxy.games.tbs.parameters.ResourceType;
import com.fossgalaxy.games.tbs.parameters.TerrainType;
import org.codetome.hexameter.core.api.CubeCoordinate;

public class DeleteTool implements Tool {

    @Override
    public void placeTerrain(MapDef def, CubeCoordinate cube, TerrainType type) {
        def.removeTerrain(cube);
    }

    @Override
    public void placeResource(MapDef def, CubeCoordinate cube, ResourceType type) {
        def.removeResource(cube);
    }

    @Override
    public void placeEntity(MapDef def, CubeCoordinate pos, EntityType selectedEntity, int owner) {
        def.removeEntity(pos);
    }

    @Override
    public String toString() {
        return "Delete";
    }
}
